package cz.boosik.boosCooldown;

import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import util.boosChat;

/**
 * Tda obsahuje veker metody potebn k zen poplatk za pkazy.
 * 
 * @author Jakub Kol
 * 
 */
public class BoosItemCostManager {
	private static String msg = "";

	/**
	 * Metoda zajiuje funkci platby za pkaz. Vrac hodnotu v zvislosti na
	 * spnosti platby.
	 * 
	 * @param player
	 *            specifikovan hr
	 * @param regexCommand
	 *            pkaz z konfigurace vyhovujc originlnmu pkazu
	 * @param originalCommand
	 *            originln pkaz pouit hrem
	 * @param item
	 * @param price
	 *            cena pouit pkazu
	 * @param name
	 *            jmno specifickho hre
	 * @return true pokud byl spn zaplacen poplatek, nebo pokud nebyl
	 *         nalezen ekonomick plugin; false pokud dolo k chyb nebo hr
	 *         neml dostatek financ
	 */
	static boolean payItemForCommand(Player player, String regexCommand,
			String originalCommand, String item, int count, String name) {
		Material material = Material.getMaterial(item);
		Inventory inventory = player.getInventory();
		Boolean trans = false;
		if (inventory.contains(material, count)) {
			ItemStack itemstack = new ItemStack(material, count);
			inventory.removeItem(itemstack);
			trans = true;
		}
		if (trans) {
			msg = String.format(
					BoosConfigManager.getPaidItemsForCommandMessage(), count
							+ " " + item);
			msg = msg.replaceAll("&command&", originalCommand);
			boosChat.sendMessageToPlayer(player, msg);
			return true;
		} else {
			// msg = String.format(
			// BoosConfigManager.getInsufficientItemsMessage(), (count
			// + " " + item));
			// msg = msg.replaceAll("&command&", originalCommand);
			// boosChat.sendMessageToPlayer(player, msg);
			return false;
		}
	}

	/**
	 * Metoda ukonuje/neukonuje udlost pouit pkazu v zvislosti na tom,
	 * jakou hodnotu vrtila metoda payForCommand(Player player, String
	 * regexCommand, String originalCommand, double price, String name);.
	 * 
	 * @param event
	 *            udlost PlayerCommandPreprocessEvent
	 * @param player
	 *            specifick hr
	 * @param regexCommand
	 *            pkaz z konfigurace vyhovujc originlnmu pkazu
	 * @param originalCommand
	 *            originln pkaz pouit hrem
	 * @param item
	 * @param price
	 *            cena pouit pkazu
	 */
	static void payItemForCommand(PlayerCommandPreprocessEvent event,
			Player player, String regexCommand, String originalCommand,
			String item, int count) {
		String name = player.getName();
		if (count > 0) {
			if (!player.hasPermission("booscooldowns.noitemcost")
					&& !player.hasPermission("booscooldowns.noitemcost."
							+ originalCommand)) {
				if (payItemForCommand(player, regexCommand, originalCommand,
						item, count, name)) {
					return;
				} else {
					BoosCoolDownManager.cancelCooldown(player, regexCommand);
					event.setCancelled(true);
					return;
				}
			}
		}
	}

	public static boolean has(Player player, String item, int count) {
		if (item.equals("")) {
			return true;
		}
		Material material = Material.getMaterial(item);
		Inventory inventory = player.getInventory();
		if (inventory.contains(material, count)) {
			return true;
		}
		return false;
	}
}
