package cz.boosik.boosCooldown.Listeners;

import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageEvent;

import util.boosChat;
import cz.boosik.boosCooldown.BoosConfigManager;
import cz.boosik.boosCooldown.BoosWarmUpManager;

/**
 * Poslucha naslouchajc udlosti, kter se spout v okamiku kdy dojde ke
 * zrann jakkoli entity ve svt. Pokud je touto entitou hr a na jeho
 * pkazech je aktivn asova warmup, ve chvli sputn tto udlosti jsou
 * vechny jeho warmup asovae stornovny a hri je odeslna zprva, kter ho
 * o tto skutenosti informuje. Pokud hr disponuje oprvnnm
 * booscooldowns.nocancel.damage, jeho warmup asovae stornovny nejsou.
 * 
 * @author Jakub Kol
 * 
 */
public class BoosEntityDamageListener implements Listener {
	/**
	 * Metoda zjiuje jestli je entita kter spustila tuto udlost hr. Pokud
	 * je entita hr, hr nen null a nedisponuje oprvnnm
	 * booscooldowns.nocancel.damage a pokud tento hr disponuje aktivnmi
	 * warmup asovai, pak je hri odeslna zprva, kter ho informuje o
	 * ukonen vech warmup asova a nsledn tyto asovae ukonuje pomoc
	 * metody cancelWarmUps();.
	 * 
	 * @param event
	 *            udlost EntityDamageEvent
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	private void onEntityDamage(EntityDamageEvent event) {
		if (event.isCancelled())
			return;

		Entity entity = event.getEntity();
		if (entity != null && entity instanceof Player) {
			Player player = (Player) entity;
			if (player != null
					&& !player.hasPermission("booscooldowns.nocancel.damage")) {
				if (BoosWarmUpManager.hasWarmUps(player)) {
					boosChat.sendMessageToPlayer(player, BoosConfigManager
							.getWarmUpCancelledByDamageMessage());
					BoosWarmUpManager.cancelWarmUps(player);
				}

			}
		}
	}
}
