package cz.boosik.boosCooldown.Listeners;

import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PlayerDeathEvent;

import cz.boosik.boosCooldown.BoosConfigManager;
import cz.boosik.boosCooldown.BoosCoolDownManager;

/**
 * Poslucha naslouchajc udlosti, kter se spout v okamiku kdy hr zeme.
 * V zvislosti na konfiguraci pluginu a oprvnnch hre mohou nastat ti
 * rzn aktivity. Cooldown asovae mohou bt po smrti vymazny, nebo naopak
 * mohou bt znovu sputny veker cooldown asovae pro veker nastaven
 * pkazy. Tak mohou bt vymazny zznamy o pouitch pkazu a hr bude opt
 * schopen pouvat limitovan pkazy a po hodnotu limitu.
 * 
 * @author Jakub Kol
 * 
 */
public class BoosPlayerDeathListener implements Listener {
	/**
	 * Metoda zjiuje jestli je entita kter spustila tuto udlost hr a
	 * jestli nen null. Na zklad toho spout dal metody.
	 * 
	 * @param event
	 *            udlost PlayerDeathEvent
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	private void onPlayerDeath(PlayerDeathEvent event) {
		Entity entity = event.getEntity();
		if (entity != null && entity instanceof Player) {
			Player player = (Player) entity;
			clearCooldownsOnDeath(player);
			clearUsesOnDeath(player);
			startCooldownsOnDeath(player);
		}
	}

	/**
	 * Na zklad konfigurace metoda spout vechny cooldown asovae
	 * specifikovanho hre tm e spust medotu startAllCooldowns();.
	 * 
	 * @param player
	 *            hr, kter spustil udlost PlayerDeathEvent
	 */
	private void startCooldownsOnDeath(Player player) {
		if (player != null) {
			if (BoosConfigManager.getStartCooldownsOnDeath()) {
				BoosCoolDownManager.startAllCooldowns(player, "");
			}
		}
	}

	/**
	 * Na zklad konfigurace a toho jestli hr disponuje oprvnnm
	 * booscooldowns.clear.uses.death metoda vymae vechny zznamy o sputn
	 * vech pkaz specifikovanho hre tm e spust metodu
	 * clearSomething();.
	 * 
	 * @param player
	 *            hr, kter spustil udlost PlayerDeathEvent
	 */
	private void clearUsesOnDeath(Player player) {
		if (player != null
				&& player.hasPermission("booscooldowns.clear.uses.death")) {
			if (BoosConfigManager.getCleanUsesOnDeath()) {
				BoosConfigManager.clearSomething("uses", player.getName()
						.toLowerCase());
			}
		}
	}

	/**
	 * Na zklad konfigurace a toho jestli hr disponuje oprvnnm
	 * booscooldowns.clear.cooldowns.death metoda vymae vechny cooldown
	 * asovae vech pkaz specifikovanho hre tm e spust metodu
	 * clearSomething();.
	 * 
	 * @param player
	 *            hr, kter spustil udlost PlayerDeathEvent
	 */
	private void clearCooldownsOnDeath(Player player) {
		if (player != null
				&& player.hasPermission("booscooldowns.clear.cooldowns.death")) {
			if (BoosConfigManager.getCleanCooldownsOnDeath()) {
				BoosConfigManager.clearSomething("cooldown", player.getName()
						.toLowerCase());
			}
		}
	}
}
