package cz.boosik.boosCooldown.Listeners;

import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerGameModeChangeEvent;

import util.boosChat;
import cz.boosik.boosCooldown.BoosConfigManager;
import cz.boosik.boosCooldown.BoosWarmUpManager;

/**
 * Poslucha naslouchajc udlosti, kter se spout v okamiku kdy hr zmn
 * hern md. Pokud na pkazech hre je aktivn asova warmup, ve chvli
 * sputn tto udlosti jsou vechny jeho warmup asovae stornovny a hri
 * je odeslna zprva, kter ho o tto skutenosti informuje. Pokud hr
 * disponuje oprvnnm booscooldowns.nocancel.gamemodechange, jeho warmup
 * asovae stornovny nejsou.
 * 
 * @author Jakub Kol
 * 
 */
public class BoosPlayerGameModeChangeListener implements Listener {
	/**
	 * Metoda zjiuje jestli je entita kter spustila tuto udlost hr. Pokud
	 * je entita hr, hr nen null a nedisponuje oprvnnm
	 * booscooldowns.nocancel.gamemodechange a pokud tento hr disponuje aktivnmi
	 * warmup asovai, pak je hri odeslna zprva, kter ho informuje o
	 * ukonen vech warmup asova a nsledn tyto asovae ukonuje pomoc
	 * metody cancelWarmUps();.
	 * 
	 * @param event
	 *            udlost PlayerGameModeChangeEvent
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	private void onPlayerGameModeChange(PlayerGameModeChangeEvent event) {
		if (event.isCancelled())
			return;

		Entity entity = event.getPlayer();
		if (entity != null && entity instanceof Player) {
			Player player = (Player) entity;
			if (player != null
					&& !player
							.hasPermission("booscooldowns.nocancel.gamemodechange")) {
				if (BoosWarmUpManager.hasWarmUps(player)) {
					boosChat.sendMessageToPlayer(player, BoosConfigManager
							.getCancelWarmupByGameModeChangeMessage());
					BoosWarmUpManager.cancelWarmUps(player);
				}

			}
		}
	}
}
