package cz.boosik.boosCooldown.Listeners;

import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerInteractEvent;

import util.boosChat;
import cz.boosik.boosCooldown.BoosConfigManager;
import cz.boosik.boosCooldown.BoosWarmUpManager;

/**
 * Poslucha naslouchajc udlosti, kter se spout v okamiku kdy hr
 * provd interakce s hernmi bloky. Pokud na pkazech hre je aktivn
 * asova warmup a blok se kterm hr interaguje je kontejner, pak tato tda
 * pot ukonuje tuto udlost a blokuje hri pstup do kontejner. Pokud hr
 * disponuje oprvnnm booscooldowns.dontblock.interact, jeho pstup do
 * kontejner nen blokovn.
 * 
 * @author Jakub Kol
 * 
 */
public class BoosPlayerInteractListener implements Listener {
	/**
	 * Metoda zjiuje jestli je entita kter spustila tuto udlost hr. Pokud
	 * je entita hr, hr nen null a nedisponuje oprvnnm
	 * booscooldowns.dontblock.interact a pokud tento hr disponuje aktivnmi
	 * warmup asovai a blok se kterm interaguje je kontejner, pak je hri
	 * odeslna zprva, kter ho informuje o tom, e do kontejneru nen mon
	 * pistupovat a tato udlost je nsledn ukonena. To zablokuje hri
	 * pstup do kontejneru.
	 * 
	 * @param event
	 *            udlost PlayerInteractEvent
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	private void onPlayerInteract(PlayerInteractEvent event) {
		if (event.isCancelled())
			return;

		Entity entity = event.getPlayer();
		if (entity != null && entity instanceof Player) {
			Player player = (Player) entity;
			if (player != null
					&& !player
							.hasPermission("booscooldowns.dontblock.interact")) {
				if (BoosWarmUpManager.hasWarmUps(player)) {
					if (event.getClickedBlock().getType().name()
							.equals("CHEST")
							|| event.getClickedBlock().getType().name()
									.equals("FURNACE")
							|| event.getClickedBlock().getType().name()
									.equals("BURNING_FURNACE")
							|| event.getClickedBlock().getType().name()
									.equals("WORKBENCH")
							|| event.getClickedBlock().getType().name()
									.equals("DISPENSER")
							|| event.getClickedBlock().getType().name()
									.equals("JUKEBOX")
							|| event.getClickedBlock().getType().name()
									.equals("LOCKED_CHEST")
							|| event.getClickedBlock().getType().name()
									.equals("ENCHANTMENT_TABLE")
							|| event.getClickedBlock().getType().name()
									.equals("BREWING_STAND")
							|| event.getClickedBlock().getType().name()
									.equals("CAULDRON")
							|| event.getClickedBlock().getType().name()
									.equals("STORAGE_MINECART")
							|| event.getClickedBlock().getType().name()
									.equals("TRAPPED_CHEST")
							|| event.getClickedBlock().getType().name()
									.equals("DROPPER")
							|| event.getClickedBlock().getType().name()
									.equals("HOPPER")) {
						event.setCancelled(true);
						boosChat.sendMessageToPlayer(player,
								BoosConfigManager.getInteractBlockedMessage());
					}
				}

			}
		}
	}
}
