package cz.boosik.boosCooldown.Listeners;

import org.bukkit.Location;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerMoveEvent;

import util.boosChat;
import cz.boosik.boosCooldown.BoosConfigManager;
import cz.boosik.boosCooldown.BoosWarmUpManager;

/**
 * Poslucha naslouchajc udlosti, kter se spout v okamiku kdy se hr
 * pohybuje. Pokud na pkazech hre je aktivn asova warmup, ve chvli
 * sputn tto udlosti jsou vechny jeho warmup asovae stornovny a hri
 * je odeslna zprva, kter ho o tto skutenosti informuje. Pi pohybech hre
 * hra tuto udlost spout 20 krt kadou vteinu. To me bt na velkch
 * serverech velmi neoptimln a proto se funkce spout jen jednou za vteinu,
 * pomoc jednoduchho cyklu. Pokud hr disponuje oprvnnm
 * booscooldowns.nocancel.move, jeho warmup asovae stornovny nejsou.
 * 
 * @author Jakub Kol
 * 
 */
public class BoosPlayerMoveListener implements Listener {
	/**
	 * Metoda zjiujc, jestli hr zmnil pozico ve svt, nebo ppadn svt
	 * od doby kdy pouil pkaz a do doby voln tto metody.
	 * 
	 * @param player
	 *            hr kter se pohybuje
	 * @return true pokud hr zmnil svou pozici, nebo pokud peel do jinho
	 *         svta; jinak vrac false
	 */
	private static boolean hasMoved(Player player) {
		String curworld = player.getWorld().getName();
		String cmdworld = BoosWarmUpManager.getPlayerworld().get(player);
		Location curloc = player.getLocation();
		Location cmdloc = BoosWarmUpManager.getPlayerloc().get(player);
		if (!curworld.equals(cmdworld)) {
			return true;
		} else if (cmdloc.distanceSquared(curloc) > 2) {
			return true;
		}

		return false;
	}

	private int tempTimer = 0;

	/**
	 * Pokud hr nen null a nedisponuje oprvnnm
	 * booscooldowns.nocancel.move a pokud tento hr disponuje aktivnmi
	 * warmup asovai, pak je hri odeslna zprva, kter ho informuje o
	 * ukonen vech warmup asova a nsledn tyto asovae ukonuje pomoc
	 * metody cancelWarmUps();. Metoda obsahuje jednoduch asova, kter
	 * zajiuje, e funkce nebudou provdny pi kadm voln tto metody (20x
	 * za vteinu).
	 * 
	 * @param event
	 *            udlost PlayerMoveEvent
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	private void onPlayerMove(PlayerMoveEvent event) {
		if (event.isCancelled()) {
			return;
		}
		if (tempTimer < 20) {
			tempTimer = tempTimer + 1;
			return;
		} else {
			Player player = event.getPlayer();
			if (player != null
					&& !player.hasPermission("booscooldowns.nocancel.move")) {
				if (BoosWarmUpManager.hasWarmUps(player) && hasMoved(player)) {
					BoosWarmUpManager.clearLocWorld(player);
					boosChat.sendMessageToPlayer(player,
							BoosConfigManager.getWarmUpCancelledByMoveMessage());
					BoosWarmUpManager.cancelWarmUps(player);
				}
			}
			tempTimer = 0;
		}
	}
}