package cz.boosik.boosCooldown.Listeners;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerToggleSprintEvent;

import util.boosChat;
import cz.boosik.boosCooldown.BoosConfigManager;
import cz.boosik.boosCooldown.BoosWarmUpManager;

/**
 * Poslucha naslouchajc udlosti, kter se spout v okamiku kdy hr zapne
 * sprintovn (pomoc dvojitho stisknut klvesy pro pohyb vped). Pokud na
 * pkazech hre je aktivn asova warmup, ve chvli sputn tto udlosti
 * jsou vechny jeho warmup asovae stornovny a hri je odeslna zprva,
 * kter ho o tto skutenosti informuje. Pokud hr disponuje oprvnnm
 * booscooldowns.nocancel.sprint, jeho warmup asovae stornovny nejsou.
 * 
 * @author Jakub Kol
 * 
 */
public class BoosPlayerToggleSprintListener implements Listener {
	/**
	 * Pokud hr nen null a nedisponuje oprvnnm
	 * booscooldowns.nocancel.sprint a pokud tento hr disponuje aktivnmi
	 * warmup asovai, pak je hri odeslna zprva, kter ho informuje o
	 * ukonen vech warmup asova a nsledn tyto asovae ukonuje pomoc
	 * metody cancelWarmUps();.
	 * 
	 * @param event
	 *            udlost PlayerToggleSprintEvent
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	private void onPlayerToggleSprint(PlayerToggleSprintEvent event) {
		if (event.isCancelled())
			return;

		Player player = event.getPlayer();
		if (player != null
				&& !player.hasPermission("booscooldowns.nocancel.sprint")) {
			if (BoosWarmUpManager.hasWarmUps(player)) {
				boosChat.sendMessageToPlayer(player,
						BoosConfigManager.getCancelWarmupOnSprintMessage());
				BoosWarmUpManager.cancelWarmUps(player);
			}

		}
	}
}